/* detect vowels -- takes a list of formants as input  */

#include "m_extern.h"
#define NFORMANT 4
#define NVOWEL 12

/* instance structure */

typedef struct vowel
{
	t_object t_ob;
	void *t_outlet;		/* the outlet */
	int template[NVOWEL][NFORMANT];
} t_vowel;

	/* The t_outlet field above is not really needed; you can find the
	outlet in the object's header of you want.  */

void vowel_bang(x)			/* bang method -- output the value */
 t_vowel *x;
{
	
}

void vowel_in1(x, n)		/* int in inlet -- add to value */
 t_vowel *x;
 long n;
{
	
}

void vowel_list(x, s, ac, av)
 t_vowel *x;
 t_symbol *s;	/* selector */
 int ac;		/* arg count */
 t_atom *av;	/* vector of arguments with types */
{
	if (ac != 4 || av[0].a_type != A_FLOAT ||
		av[1].a_type != A_FLOAT ||
		av[2].a_type != A_FLOAT ||
		av[3].a_type != A_FLOAT)
	{
		error("vowel: bad list");
		return;
	}
}

void vowel_free()
{
}

t_externclass *vowel_class;

void *vowel_new()
{
	t_vowel *x = (t_vowel *)obj_new(&vowel_class, 0);
	x->t_outlet = outlet_new(x, gensym("float"));
	inlet_new(x, x, gensym("int"), gensym("in1"));
	x->t_state = 1234.;
	return (x);
}

vowel_setup()
{
	c_extern(&vowel_class, vowel_new, vowel_free, gensym("vowel"),
		sizeof(t_vowel), 0, 0);
	c_addbang(vowel_bang);
	c_addint(vowel_int);
	c_addfloat(vowel_float);
	c_addmess(vowel_in1, gensym("in1"), A_LONG, 0);
	c_addmess(vowel_list, gensym("list"), A_GIMME, 0);
}
